#!/bin/sh

download_debian_10_if_needed() {
if [ ! -d debian-installer ]
then
  rm -f netboot.tar.gz
  rm -f grubx64.efi
  wget http://ftp.debian.org/debian/dists/buster/main/installer-amd64/current/images/netboot/netboot.tar.gz
  tar -xzvf netboot.tar.gz
  ln -s debian-installer/amd64/grubx64.efi 
fi
}
download_debian_11_if_needed() {
if [ ! -d debian-installer ]
then
  rm -f netboot.tar.gz
  rm -f grubx64.efi
  wget http://ftp.debian.org/debian/dists/bullseye/main/installer-amd64/current/images/netboot/netboot.tar.gz
  tar -xzvf netboot.tar.gz
  ln -s debian-installer/amd64/grubx64.efi
fi
}
download_sysrescuecd_if_needed() {
if [ ! -f sysresccd/sysresccd/pkglist.x86_64.txt ]
then
  wget https://jztkft.dl.sourceforge.net/project/systemrescuecd/sysresccd-x86/8.01/systemrescue-8.01-amd64.iso
  mkdir -p sysresccd
  mount -o loop systemrescue-8.01-amd64.iso sysresccd
fi
}
download_centos_8_if_needed() {
if [ ! -f centos-installer/.treeinfo ]
then
  if [ ! -f CentOS-8.2.2004-x86_64-minimal.iso ]
  then
    wget http://mirrors.neterra.net/centos/8.2.2004/isos/x86_64/CentOS-8.2.2004-x86_64-minimal.iso
  fi
  mkdir -p centos-installer
  mount -o loop CentOS-8.2.2004-x86_64-minimal.iso centos-installer
fi
}
download_ubuntu_20_if_needed() {
download_debian_10_if_needed
if [ ! -d ubuntu-installer ]
then
  rm -f netboot.tar.gz
  wget http://archive.ubuntu.com/ubuntu/dists/focal/main/installer-amd64/current/legacy-images/netboot/netboot.tar.gz
  tar -xzvf netboot.tar.gz
fi
}
