#!/bin/sh
set -e

SCRIPT_DIR=$(realpath `dirname "$0"`)


. $SCRIPT_DIR/download_boot_systems.sh

download_debian_10_if_needed
#download_sysrescuecd_if_needed

#UPDATE THOSE VARIABLES DEPENDING ON YOUR SITE
MY_IF_NAME=eth0
MY_IP_ADDR=192.168.46.2
DHCP_RANGE=192.168.46.100,static,255.255.255.0
ROUTER_ADDR=192.168.46.2
DNS_SERVER=1.1.1.1

#This is to make linux output visible in IPMI SOL. Remove if you are using a graphical card.
common=console=ttyS1,57600

mac='
00:22:4d:dd:64:f8
00:22:4d:dd:65:38
00:22:4d:dd:64:4a
00:22:4d:dd:64:f0
'
i=1
hostname_prefix=muc-internetx-capri-

(
#echo set timeout=0
echo if false
echo then true
for mac in $mac; do
  echo "elif [ \$net_default_mac = $mac ]"
  echo then set i=`printf %03u $i`
  i=`expr $i + 1`
done
cat <<EOF
else unset timeout
fi

menuentry 'Install Debian' {
  linux /debian-installer/amd64/linux vga=788 url=tftp://\$pxe_default_server/preseed.cfg language=C country=DE keymap=de hostname=${hostname_prefix}\$i domain= --- mitigations=off $common
  initrd /debian-installer/amd64/initrd.gz
}
#menuentry 'SystemRescueCd' {
#  linux /sysresccd/sysresccd/boot/x86_64/vmlinuz archisobasedir=sysresccd archiso_http_srv=http://\$pxe_default_server:69/sysresccd/ checksum ip=dhcp $common
#  initrd /sysresccd/sysresccd/boot/intel_ucode.img /sysresccd/sysresccd/boot/amd_ucode.img /sysresccd/sysresccd/boot/x86_64/sysresccd.img
#}
menuentry 'Exit' {
  exit
}
EOF
) >debian-installer/amd64/grub/grub.cfg

i=1
for mac in $mac
do
  hostname=${hostname_prefix}$(printf %03u $i)
  mkdir -p $hostname
  cat > $hostname/interfaces <<EOF
# This file describes the network interfaces available on your system
# and how to activate them. For more information, see interfaces(5).

source /etc/network/interfaces.d/*

# The loopback network interface
auto lo
iface lo inet loopback

# The Rj45 interace
allow-hotplug eno1
iface eno1 inet dhcp

# The first SFP+ interface
allow-hotplug enp193s0f0
iface enp193s0f0 inet static
  address 85.236.52.$(( 76 + $i ))/29
  gateway 85.236.52.73
  dns-nameservers 62.116.162.126 62.116.130.3 85.236.36.4

# The second SFP+ interace (not used)
#iface-hotplug enp193s0f1
#iface enp193s0f1 inet dhcp

EOF
  i=`expr $i + 1`
done

exec dnsmasq -d --port=0 --log-dhcp \
  --interface=$MY_IF_NAME \
  --bind-interfaces \
  --except-interface=lo \
  --listen-address=$MY_IP_ADDR \
  --dhcp-range=$DHCP_RANGE \
  --dhcp-option=option:router,$ROUTER_ADDR \
  --dhcp-option=option:dns-server,$DNS_SERVER \
  --dhcp-boot=debian-installer/amd64/grubx64.efi \
  --enable-tftp --tftp-root=$(realpath `dirname "$0"`) \
  --conf-file=/dev/null \
  --dhcp-host=00:22:4d:dd:64:f9,192.168.46.102,1h \
  --dhcp-host=00:22:4d:dd:65:39,192.168.46.103,1h \
  --dhcp-host=00:22:4d:dd:64:4b,192.168.46.104,1h \
  --dhcp-host=00:22:4d:dd:64:f1,192.168.46.105,1h \
  --dhcp-host=00:22:4d:dd:64:f8,192.168.46.106,1h \
  --dhcp-host=00:22:4d:dd:65:38,192.168.46.107,1h \
  --dhcp-host=00:22:4d:dd:64:4a,192.168.46.108,1h \
  --dhcp-host=00:22:4d:dd:64:f0,192.168.46.109,1h \
